<template>
  <div class="sign-in-section">
    <div class="wrap-content position-relative py-5">
      <img
        src="@/assets/img/game_overlay.png"
        class="position-absolute top-0 start-0 w-100"
        style="height: 100%; object-fit: cover; z-index: -1"
      />
      <div class="content-section container">
        <div class="row justify-content-center">
          <div class="col col-11 col-lg-7">
            <div class="form-wrap py-4 py-lg-5 px-4 px-lg-5">
              <h2 class="text-danger fw-bold text-center mb-3 mb-lg-5">
                Sign In
              </h2>
              <div class="d-flex align-items-center mb-4">
                <i
                  class="far fa-envelope text-danger"
                  style="font-size: 32px"
                ></i>
                <input
                  type="email"
                  class="form-control form-control-lg border-danger border-2 ms-2"
                  id="username"
                  placeholder="name@example.com"
                  v-model="emailUser"
                />
              </div>
              <div class="d-flex align-items-center mb-4">
                <i class="fas fa-lock text-danger" style="font-size: 32px"></i>
                <input
                  type="password"
                  class="form-control form-control-lg border-2 border-danger ms-2"
                  id="password"
                  placeholder="******"
                  v-model="pwdUser"
                  @keypress.enter="signIn"
                />
              </div>
              <div class="d-flex justify-content-between mt-4">
                <div class="remember-me">
                  <input
                    class="form-check-input"
                    type="checkbox"
                    v-model="rememberMe"
                    id="rememberme"
                  />
                  <label
                    class="form-check-label ms-2"
                    for="rememberme"
                    style="opacity: 0.7"
                  >
                    Remember me
                  </label>
                </div>
                <!-- <p
                  class="forgot-pwd m-0"
                  style="opacity: 0.7; margin-top: 3px !important"
                >
                  Forgot password?
                </p> -->
              </div>
              <div
                class="d-flex justify-content-center mb-3 mt-3 mt-lg-5 brand-img"
              >
                <img
                  src="@/assets/img/ic_fb.png"
                  style="width: 60px; cursor: pointer; object-fit: contain;"
                  @click="fbLogin"
                />
                <!-- <img src="@/assets/img/ic_apple.png" style="width: 60px; cursor: pointer" />
                <img src="@/assets/img/ic_talk.png" style="width: 60px; cursor: pointer" /> -->
                <img
                  @click="loginWithGoogle"
                  src="@/assets/img/ic_google.png"
                  style="width: 60px; cursor: pointer; object-fit: contain;"
                />
              </div>
              <div class="d-flex justify-content-center pt-4">
                <button
                  class="btn btn-danger rounded-pill px-5 py-1 px-lg-5 py-lg-2"
                  style="font-size: 22px"
                  @click="signIn"
                >
                  Sign In
                </button>
              </div>
              <p
                class="text-end text-danger mt-2"
                style="font-size: 18px; cursor: pointer"
                @click="$router.push('/signup').catch(() => {})"
              >
                Sign Up
                <i class="fas fa-chevron-right ms-2"></i>
              </p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { apiCustomerPost } from "../services/baseApi.js";
import { fbAuth } from "../services/authSocial.js";
import sweetAlert from "../helper/sweetAlert.js";

export default {
  data() {
    return {
      emailUser: "",
      pwdUser: "",
      rememberMe: true,
    };
  },
  mounted() {},
  methods: {
    async loginWithGoogle() {
      try {
        const GoogleUser = await this.$gAuth.signIn();
        const res = await apiCustomerPost("auth/login/gg", {
          name: GoogleUser.getBasicProfile().getName(),
          email: GoogleUser.getBasicProfile().getEmail(),
          avatar: GoogleUser.getBasicProfile().getImageUrl()
        });
        if (!res || !res.data || !res.data.status || !res.data.data) return;
        localStorage.setItem("token", res.data.data.token);
        this.$router.push("/").catch(() => {});
      } catch (error) {
        console.log(error);
      }
    },
    async signIn() {
      try {
        if (!this.emailUser || !this.pwdUser) {
          sweetAlert.toastAlert(
            this,
            "error",
            "Please enter all required information"
          );
          return;
        }

        let res = await apiCustomerPost("auth/login", {
          email: this.emailUser,
          password: this.pwdUser,
        });

        // Save Token
        if (!res || !res.data || !res.data.status || !res.data.data) return;
        localStorage.removeItem("user");
        localStorage.removeItem("token");
        localStorage.setItem("token", res.data.data.token);
        this.$router.push('/').catch(() => {});
      } catch (error) {
        console.log(error.response.data.message);
        if (
          error.response &&
          error.response.data &&
          error.response.data.message
        ) {
          sweetAlert.toastAlert(this, "error", error.response.data.message);
          return;
        }

        sweetAlert.toastAlert(this, "error", "Your Signin has failed");
      }
    },
    fbLogin() {
      fbAuth(this);
    },
  },
};
</script>

<style scoped>
.wrap-content {
  min-height: 100vh;
}
.form-wrap {
  background: #fff;
  border-radius: 32px;
}
#username,
#password {
  border-top: none;
  border-left: none;
  border-right: none;
  border-radius: 0;
}

@media screen and (max-width: 991px) {
  i {
    font-size: 22px !important;
  }
  .brand-img img {
    width: 42px !important;
  }
  .remember-me label,
  .forgot-pwd {
    font-size: 14px !important;
  }
}
</style>
